View subclass:#JavaView
	instanceVariableNames:'eventReceiver updateRegions javaPeer'
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Views-Support'
!


!JavaView methodsFor:'accessing'!

delegate:anObject
    super delegate:anObject.
    eventReceiver := anObject.

    "Created: 18.8.1997 / 15:22:20 / cg"
!

getNextUpdateRectangle
    |r|

    updateRegions size == 0 ifTrue:[^ nil].
    r := updateRegions removeFirst.
    updateRegions size == 0 ifTrue:[updateRegions := nil].
    ^ r

    "Created: 18.8.1997 / 15:37:31 / cg"
!

javaPeer
    "for debugging support - here is a handle to the corresponding
     javaPeer"

    ^ javaPeer

    "Created: 18.8.1997 / 22:34:35 / cg"
!

javaPeer:aJavaView
    "for debugging support - here is a handle to the corresponding
     javaPeer"

    javaPeer := aJavaView

    "Created: 18.8.1997 / 22:34:30 / cg"
! !

!JavaView methodsFor:'event handling'!

exposeX:x y:y width:w height:h
    |ev rect|

    rect := Rectangle left:x top:y width:w height:h.

"/ 'JavaView expose' printCR.

    updateRegions isNil ifTrue:[
        updateRegions := OrderedCollection new.
    ].
    updateRegions add:rect.
    eventReceiver notNil ifTrue:[
        ev := WindowEvent 
                damageFor:self 
                rectangle:rect. 
        eventReceiver processEvent:ev.
    ].
"/    super exposeX:x y:y width:w height:h

    "Created: / 18.8.1997 / 15:00:24 / cg"
    "Modified: / 19.10.1998 / 23:10:15 / cg"
! !

!JavaView methodsFor:'initialization'!

initialize
    super initialize.

    self enableMotionEvents.
    (superView notNil and:[superView isMemberOf:JavaEmbeddedFrameView])
    ifTrue:[
        self viewBackground:superView viewBackground
    ]

    "Created: / 21.8.1997 / 16:37:45 / cg"
    "Modified: / 13.1.1998 / 14:29:30 / cg"
! !

!JavaView class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaView.st,v 1.15 1998/12/03 13:07:11 cg Exp $'
! !
